﻿using GameUtils.Math;

namespace GameUtils.Graphics.Data
{
    /// <summary>
    /// Erstellt Ressourcen für einen Renderer.
    /// </summary>
    public abstract class Factory
    {
        protected internal abstract SolidColorBrushData CreateSolidColorBrush(Color4 color);

        protected internal abstract LinearGradientBrushData CreateLinearGradientBrush(GradientStop[] stops, Vector2 start, Vector2 end);

        protected internal abstract RadialGradientBrushData CreateRadialGradientBrush(GradientStop[] stops, Vector2 center, float radiusX, float radiusY);

        protected internal abstract TextureBrushData CreateTextureBrush(Texture texture);

        protected internal abstract GeometryData CreateGeometry();

        protected internal abstract FontData CreateFont(string familyName, float size, FontStyle style, FontWeight weight);

        protected internal abstract TextureData CreateTexture(string path);

        protected internal abstract TextureData CreateTexture(System.IO.Stream stream);

        protected internal abstract TextFormatData CreateTextFormat();
    }
}
